//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#include <stdio.h>
#include <FileCtrl.hpp> // para o SelectDirectory
#include <Printers.hpp> // para a impressora
#include <string.h> // strtof
#pragma hdrstop
#include "Unit1.h"

#define MAX(a,b) ((a > b) ? a : b)
#define MIN(a,b) ((a < b) ? a : b)

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
bool STL_esta_carregado = false;

int Ang = 0;

char *cache_stl = NULL;
unsigned int *ntt = NULL;
float *normal = NULL, *vertices = NULL, *cache_tmp = NULL, *cache_tmpy = NULL, *p = NULL;
FILE *imagem;
Graphics::TBitmap *pBitmap = NULL;

unsigned int Delay = 100;
unsigned int Delay_Pos = 0;

TPrinter *Prntr = Printer();
int PrinterDPIX = GetDeviceCaps(Prntr->Handle,LOGPIXELSX);
int PrinterDPIY = GetDeviceCaps(Prntr->Handle,LOGPIXELSY);
int PrinterHORZRES = GetDeviceCaps(Prntr->Handle,HORZRES);
int PrinterVERTRES = GetDeviceCaps(Prntr->Handle,VERTRES);

unsigned int linhas; // linhas nao horizontais que forao intersectadas
unsigned int linhas_slf; // linhas interceptadas no scanline-fill
unsigned int slice; // usado no numero do bmp
unsigned int slice_totais; // numero totais de fatias dado por (altura/incremento)
unsigned int slice_primeira; // primeira fatia
unsigned int slice_ultima; // ultima fatia

float menor[3]; // menor cordenada
float maior[3]; // maior cordenada
float _menor[2]; // menor cordenada 2D
float _maior[2]; // maior cordenada 2D

float incremento = 1.0; // incremento de cada fatia
float fator; // calculo da media
float diff; // diferena

double z; // posicao atual da fatia
double y; // posicao atual do scanline-fill

unsigned int BiWidth; // largura da imagem
unsigned int BiHeight; // altura da imagem
unsigned int BiXPPMeter;
unsigned int BiYPPMeter;
unsigned int BytesPerLine;

char *buffer_linha; // ponteiro para o buffer da linha

AnsiString Dir = ""; // diretorio de sada dos bmp's
char prefixo[32]; // diretorio de sada dos bmp's
char sufixo[32]; // diretorio de sada dos bmp's
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
int __fastcall TForm1::Carrega_STL_Para_Memoria()
{
   unsigned int size = 0;
   FILE *stl = fopen(OpenDialog1->FileName.c_str(), "rb");
   if(stl == NULL)
   {
	  Application->MessageBox("Fail to open file for reading", "Error", MB_OK + MB_ICONERROR);
	  return 0;
   }
   // pega o tamanho
   fseek(stl, 0, SEEK_END);
   size = ftell(stl);
   fseek(stl, 0, SEEK_SET);
   // verifica se  menor que 4 faces
   if(size < 284)
   {
	  Application->MessageBox("File too small to contain data", "Error", MB_OK + MB_ICONERROR);
	  return 0;
   }
   // l o cabecalho
   char cabecalho[6];
   if(fread(&cabecalho, 1, 6, stl) != 6)
   {
	  fclose(stl); // fecha o arquivo
	  Application->MessageBox("Error reading the file", "Error", MB_OK + MB_ICONERROR);
	  return 0;
   }
   // verifica se  binario
   if(cabecalho[0] == 's' &&
	  cabecalho[1] == 'o' &&
	  cabecalho[2] == 'l' &&
	  cabecalho[3] == 'i' &&
	  cabecalho[4] == 'd' &&
	  cabecalho[5] == ' ') {
	  //Transforma em Binrio, nao implementado ainda
	  Application->MessageBox("The file must be binary", "Error", MB_OK + MB_ICONERROR);
	  return 0;
   }

   // pega o numero de triangulos
   fseek(stl,80,SEEK_SET);
   unsigned int ntt_temp;
   if(fread(&ntt_temp, 4, 1, stl) != 1)
   {
	  fclose(stl); // fecha o arquivo
	  Application->MessageBox("Error reading the file", "Error", MB_OK + MB_ICONERROR);
	  return 0;
   }
   // verifica se o tamanho do arquivo esta correto
   if((ntt_temp*50)+84 != size)
   {
	  Application->MessageBox("Number of triangles not matched the file size", "Error", MB_OK + MB_ICONERROR);
	  return 0;
   }
   // limpa memoria para carregar novo arquivo
   free(cache_stl);
   // aloca espaco para arquivo
   if((cache_stl =(char *) malloc(size)) == NULL)
   {
	  Application->MessageBox("Out of memory", "Error", MB_OK + MB_ICONERROR);
	  return -1;
   }
   // carrega o arquivo para a memoria
   fseek(stl,0,SEEK_SET);
   if(fread(cache_stl, 1, size, stl) != size)
   {
	  fclose(stl); // fecha o arquivo
	  Application->MessageBox("Error reading the file", "Error", MB_OK + MB_ICONERROR);
	  return -1;
   }
   // fecha o arquivo
   fclose(stl);
   ntt = (unsigned int *) &cache_stl[80];
   return size;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonProcurarClick(TObject *Sender)
{
   while(1)
   {
	  if(OpenDialog1->Execute())
	  {
		 int asd = Carrega_STL_Para_Memoria();
		 if(asd == -1)
		 {
			free(cache_stl);
			cache_stl = NULL;
			STL_esta_carregado = false;
			// bloqueia os botoes igual ao inicio
			DesabilitaAbilita(0);
			break;
		 }
		 else if(asd > 0)
		 {
			STL_esta_carregado = true;
			Pega_ABS();
			Imprime_Cabecalho_Triangulos();
			EditIncrementoChange(Sender); // atualiza o numero de fatias
			// abilita botoes antes de imprimir
			DesabilitaAbilita(1);
			break;
		 }
	  }
	  else break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Imprime_Cabecalho_Triangulos()
{
   Memo1->Lines->Clear();
   Memo1->Lines->Strings[0] = OpenDialog1->FileName;
   Memo1->Lines->Add("Header: " );//+ cabecalho[0]);
   for(int i = 0; i < 80; i++)
   {
	   if(cache_stl[i] < 32) break;
	   Memo1->Lines->Strings[1] = Memo1->Lines->Strings[1] + cache_stl[i];
   }
   Memo1->Lines->Add("Triangles: " + IntToStr(*ntt));
   Memo1->Lines->Add("Max: " + FloatToStr(maior[0]) + " " + FloatToStr(maior[1]) + " " + FloatToStr(maior[2]));
   Memo1->Lines->Add("Min: " + FloatToStr(menor[0]) + " " + FloatToStr(menor[1]) + " " + FloatToStr(menor[2]));
   Memo1->Lines->Add("Size: " + FloatToStr(maior[0]-menor[0]) + " " + FloatToStr(maior[1]-menor[1]) + " " + FloatToStr(maior[2]-menor[2]));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Pega_ABS(void)
{
   for(unsigned int x = 0; x < (*ntt-1); x++)
   {
	  vertices = (float *) &cache_stl[96+(x*50)];
	  if(x == 0)
	  {
		 menor[0] = vertices[0]; maior[0] = vertices[0];
		 menor[1] = vertices[1]; maior[1] = vertices[1];
		 menor[2] = vertices[2]; maior[2] = vertices[2];
	  }
	  else
	  {
		 if(menor[0] > vertices[0]) menor[0] = vertices[0];
		 if(menor[1] > vertices[1]) menor[1] = vertices[1];
		 if(menor[2] > vertices[2]) menor[2] = vertices[2];
		 if(maior[0] < vertices[0]) maior[0] = vertices[0];
		 if(maior[1] < vertices[1]) maior[1] = vertices[1];
		 if(maior[2] < vertices[2]) maior[2] = vertices[2];
	  }
	  if(menor[0] > vertices[3]) menor[0] = vertices[3];
	  if(menor[0] > vertices[6]) menor[0] = vertices[6];
	  if(menor[1] > vertices[4]) menor[1] = vertices[4];
	  if(menor[1] > vertices[7]) menor[1] = vertices[7];
	  if(menor[2] > vertices[5]) menor[2] = vertices[5];
	  if(menor[2] > vertices[8]) menor[2] = vertices[8];

	  if(maior[0] < vertices[3]) maior[0] = vertices[3];
	  if(maior[0] < vertices[6]) maior[0] = vertices[6];
	  if(maior[1] < vertices[4]) maior[1] = vertices[4];
	  if(maior[1] < vertices[7]) maior[1] = vertices[7];
	  if(maior[2] < vertices[5]) maior[2] = vertices[5];
	  if(maior[2] < vertices[8]) maior[2] = vertices[8];
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Esta_Entre(void)
{
   linhas = 0; // inicializa a variavel
   cache_tmp = NULL; // inicializa a variavel para que quando for
					 // usado o realloc funcionara igual ao malloc
   for(unsigned int x = 0; x < *ntt; x++)
   {
	  vertices = (float *) &cache_stl[96+(x*50)];
	  float final[3][2];
	  int cnt=0, cntpos=0;
	  if(vertices[2] == z)
	  {
		 final[cnt][0] = vertices[0];
		 final[cnt][1] = vertices[1];
		 cnt++; cntpos += 1;
	  }
	  if(vertices[5] == z)
	  {
		 final[cnt][0] = vertices[3];
		 final[cnt][1] = vertices[4];
		 cnt++; cntpos += 2;
	  }
	  if(vertices[8] == z)
	  {
		 final[cnt][0] = vertices[6];
		 final[cnt][1] = vertices[7];
		 cnt++; cntpos += 4;
	  }
	  if((vertices[2] > z && vertices[5] < z) || (vertices[5] > z && vertices[2] < z))
	  {
		 diff = MAX(vertices[2],vertices[5]) - MIN(vertices[2],vertices[5]);
		 fator = (z-MIN(vertices[2],vertices[5]))/diff;
		 if(vertices[2] < vertices[5])
		 {
			final[cnt][0] = (((vertices[3] - vertices[0]) * fator) + vertices[0]);
			final[cnt][1] = (((vertices[4] - vertices[1]) * fator) + vertices[1]);
			cnt++;
		 }
		 else
		 {
			final[cnt][0] = (((vertices[0] - vertices[3]) * fator) + vertices[3]);
			final[cnt][1] = (((vertices[1] - vertices[4]) * fator) + vertices[4]);
			cnt++;
		 }
	  }
	  if((vertices[2] > z && vertices[8] < z) || (vertices[8] > z && vertices[2] < z))
	  {
		 diff = MAX(vertices[2],vertices[8]) - MIN(vertices[2],vertices[8]);
		 fator = (z-MIN(vertices[2],vertices[8]))/diff;
		 if(vertices[2] < vertices[8])
		 {
			final[cnt][0] = (((vertices[6] - vertices[0]) * fator) + vertices[0]);
			final[cnt][1] = (((vertices[7] - vertices[1]) * fator) + vertices[1]);
			cnt++;
		 }
		 else
		 {
			final[cnt][0] = (((vertices[0] - vertices[6]) * fator) + vertices[6]);
			final[cnt][1] = (((vertices[1] - vertices[7]) * fator) + vertices[7]);
			cnt++;
		 }
	  }
	  if((vertices[8] > z && vertices[5] < z) || (vertices[5] > z && vertices[8] < z))
	  {
		 diff = MAX(vertices[8],vertices[5]) - MIN(vertices[8],vertices[5]);
		 fator = (z-MIN(vertices[8],vertices[5]))/diff;
         if(vertices[8] < vertices[5])
		 {
            final[cnt][0] = (((vertices[3] - vertices[6]) * fator) + vertices[6]);
            final[cnt][1] = (((vertices[4] - vertices[7]) * fator) + vertices[7]);
            cnt++;
         }
		 else
		 {
			final[cnt][0] = (((vertices[6] - vertices[3]) * fator) + vertices[3]);
			final[cnt][1] = (((vertices[7] - vertices[4]) * fator) + vertices[4]);
            cnt++;
		 }
      }
	  if(cnt == 1 && cntpos > 0) // ponto
      {
         //printf("\n#%ld P - %f %f", x+1, final[0][0], final[0][1]);
	  }
	  if(cnt == 2) // linha
      {
		 if(cntpos == 0)
         {
			//printf("\n#%ld L - %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1]);
			if((p = (float *) realloc (cache_tmp, (linhas+1)*16)) == NULL)
			{
			   Application->MessageBox("Error relocate the memory", "Error", MB_OK + MB_ICONERROR);
			   exit(7);
			}
			cache_tmp = p;
            cache_tmp[(linhas*4)+0] = final[0][0];
            cache_tmp[(linhas*4)+1] = final[0][1];
            cache_tmp[(linhas*4)+2] = final[1][0];
            cache_tmp[(linhas*4)+3] = final[1][1];
			linhas++;
		 }
		 else if((cntpos == 1) || (cntpos == 2) || (cntpos == 4))
		 {
            //printf("\n#%ld PL - %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1]);
			if(final[0][1] != final[1][1])
            {
			   if((p = (float *) realloc (cache_tmp, (linhas+1)*16)) == NULL)
               {
				  Application->MessageBox("Error relocate the memory", "Error", MB_OK + MB_ICONERROR);
				  exit(7);
			   }
               cache_tmp = p;
			   cache_tmp[(linhas*4)+0] = final[0][0];
               cache_tmp[(linhas*4)+1] = final[0][1];
			   cache_tmp[(linhas*4)+2] = final[1][0];
			   cache_tmp[(linhas*4)+3] = final[1][1];
			   linhas++;
            }
		 }
         else
		 {
            //printf("\n#%ld FL - %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1]);
            if(final[0][1] != final[1][1])
            {
			   if(RadioButton1->Checked)
			   {
				  if((vertices[2] < z) || (vertices[5] < z) || (vertices[8] < z))
				  {
					 if((p = (float *) realloc (cache_tmp, (linhas+1)*16)) == NULL)
					 {
						Application->MessageBox("Error relocate the memory", "Error", MB_OK + MB_ICONERROR);
						exit(7);
					 }
					 cache_tmp = p;
					 cache_tmp[(linhas*4)+0] = final[0][0];
					 cache_tmp[(linhas*4)+1] = final[0][1];
					 cache_tmp[(linhas*4)+2] = final[1][0];
					 cache_tmp[(linhas*4)+3] = final[1][1];
					 linhas++;
				  }
			   }
			   else
			   {
				  if((vertices[2] > z) || (vertices[5] > z) || (vertices[8] > z))
				  {
					 if((p = (float *) realloc (cache_tmp, (linhas+1)*16)) == NULL)
					 {
						Application->MessageBox("Error relocate the memory", "Error", MB_OK + MB_ICONERROR);
						exit(7);
					 }
					 cache_tmp = p;
					 cache_tmp[(linhas*4)+0] = final[0][0];
					 cache_tmp[(linhas*4)+1] = final[0][1];
					 cache_tmp[(linhas*4)+2] = final[1][0];
					 cache_tmp[(linhas*4)+3] = final[1][1];
					 linhas++;
				  }
			   }
			}
		 }
	  }
	  if(cnt == 3 && cntpos == 7) // face
	  {
		//printf("\n#%ld F - %f %f %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1], final[2][0], final[2][1]);
	  }
	  if((cnt == 3 && cntpos != 7) || (cnt > 3) || (cnt == 1 && cntpos == 0)) // erros que nunca dariam
	  {
		 Application->MessageBox(("Warning - triangle: " + IntToStr(x+1) + " height: " + FloatToStr(z) + " cnt: " + IntToStr(cnt) + " cntpos: " + IntToStr(cntpos)).c_str(), "Error", MB_OK + MB_ICONERROR);
	  }
   } // fim do loop de triangulos
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Pega_ABS_Fatia(void)
{
   for(unsigned int x = 0; x < (linhas*2); x++)
   {
	  vertices = &cache_tmp[x*2];
	  if(x == 0)
	  {
		 _menor[0] = vertices[0]; _maior[0] = vertices[0];
		 _menor[1] = vertices[1]; _maior[1] = vertices[1];
	  }
	  else
	  {
		 if(_menor[0] > vertices[0]) _menor[0] = vertices[0];
		 if(_menor[1] > vertices[1]) _menor[1] = vertices[1];
		 if(_maior[0] < vertices[0]) _maior[0] = vertices[0];
		 if(_maior[1] < vertices[1]) _maior[1] = vertices[1];
	  }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Ordena_SLF(void)
{
   for(unsigned int x = 0; x < linhas_slf; x++)
   {
	  if(x == (linhas_slf-1)) break; // para corrigir um bug estranho
	  float origem = cache_tmpy[x];
	  unsigned int pmin = x;
	  for(unsigned int i = (x+1); i < linhas_slf; i++)
	  {
		 if(cache_tmpy[x] > cache_tmpy[i])
		 {
			cache_tmpy[x] = cache_tmpy[i];
			pmin = i;
		 }
	  }
	  if(pmin != x)
	  {
		 cache_tmpy[pmin] = origem;
	  }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonImprimirClick(TObject *Sender)
{
   Timer1->Enabled = false;
   ButtonPausar->Enabled = false;
   if(ButtonImprimir->Enabled) // somente entra na primeira vez
   {
	  int Largura = ((maior[0]-menor[0])/(25.4/float(PrinterDPIX)));
	  int Altura = ((maior[1]-menor[1])/(25.4/float(PrinterDPIY)));
	  if(PrinterDPIX < 1 || PrinterDPIY < 1)
	  {
		 Application->MessageBox("The resolution of the printer is less than 1", "Error", MB_OK + MB_ICONERROR);
		 return;
	  }
	  if((int((maior[0]-menor[0])/(25.4/PrinterDPIX)) > PrinterHORZRES) || (int((maior[1]-menor[1])/(25.4/PrinterDPIY)) > PrinterVERTRES))
	  {
		 Application->MessageBox(("The size of the object is larger than the print area.\nSize available for printing: x = " +
		 IntToStr(PrinterHORZRES) + " y = " + IntToStr(PrinterVERTRES) + "\nSize of object: x = " + IntToStr(Largura) + " y = " + IntToStr(Altura)).c_str(), "Error", MB_OK + MB_ICONERROR);
		 return;
	  }
	  DesabilitaAbilita(2);
	  if(RadioButton1->Checked)
	  {
		 z = maior[2];
	  }
	  else
	  {
		 z = menor[2];
	  }
	  slice_primeira = atoi(EditPrimeiraFatia->Text.c_str());
	  // para prevenir erros
	  if(slice_primeira == 0)
	  {
		 slice_primeira++; // muda para 1
		 EditPrimeiraFatia->Text = 1;
	  }
	  slice = slice_primeira; // seta o primeiro slice
	  slice_totais = 0;
	  for(double kz = maior[2]; kz > menor[2]; kz -= incremento)
		 slice_totais++; // arruma o numero maximo de fatias
   }

   if(RadioButton1->Checked)
   {
	  if(EditProximaFatia->Text != "")
	  {
		 unsigned int slice_i = atoi(EditProximaFatia->Text.c_str());
		 if(slice_i == 0) slice_i = 1;
		 if(slice_i > slice_totais)
		 {
			int entrada = atoi(InputBox("Next slice is outside the limit",("Enter a value between 1 and " + IntToStr(slice_totais)).c_str(),"").c_str());
			if(entrada != 0)
			{
			   slice_i = entrada;
			}
		 }
		 slice = slice_i;
	  }
	  // pula at o slice atual
	  unsigned int slice_a = 0;
	  double kz = maior[2];
	  while(slice_a < slice)
	  {
		 z = kz;
		 slice_a++;
		 kz -= incremento;
	  }
	  // verifica se j passou fora do modelo
	  if(z <= menor[2])
	  {
		 DesabilitaAbilita(3); // fim
		 return;
	  }
   }
   else
   {
	  if(EditProximaFatia->Text != "")
	  {
		 unsigned int slice_i = atoi(EditProximaFatia->Text.c_str());
		 if(slice_i == 0) slice_i = 1;
		 if(slice_i > slice_totais)
		 {
			int entrada = atoi(InputBox("Next slice is outside the limit",("Enter a value between 1 and " + IntToStr(slice_totais)).c_str(),"").c_str());
			if(entrada != 0)
			{
			   slice_i = entrada;
			}
		 }
		 slice = slice_i;
	  }
	  // pula at o slice atual
	  unsigned int slice_a = 0;
	  double kz = menor[2];
	  while(slice_a < slice)
	  {
		 z = kz;
		 slice_a++;
		 kz += incremento;
	  }
	  // verifica se j passou fora do modelo
	  if(z >= maior[2])
	  {
		 DesabilitaAbilita(3); // fim
		 return;
	  }
   }
   delete pBitmap;
   pBitmap = NULL; // para quando deletar denovo nao der erro.

   Esta_Entre(); // verifica quais faces entao entre o eixo z fatiado
   if(linhas == 0) // se nenhuma, volta no loop
   {
	  // para apagar o desenho
	  Image1->Width = 0;
	  Image1->Height = 0;
	  // impressao inicia aqui
	  char titulo[32];
	  sprintf(titulo, "Slice %u (empty)", slice);
	  Label3->Caption = "Printing Slice " + IntToStr(slice) + "\n(empty)";
	  if(CheckBoxImprimir->Checked)
	  {
		 Prntr->Title = titulo;
		 Prntr->BeginDoc(); // inicio da impresso
		 Prntr->EndDoc();  // fim da impresso
	  }
	  // incremento
	  slice++;
	  if(RadioButton1->Checked)
	  {
		 z -= incremento;
		 if(z <= menor[2])
		 {
			// fim
			DesabilitaAbilita(3);
			return;
		 }
	  }
	  else
	  {
		 z += incremento;
		 if(z >= maior[2])
		 {
			// fim
			DesabilitaAbilita(3);
			return;
		 }
	  }

	  // verifica se no  a ultima fatia
	  slice_ultima = atoi(EditUltimaFatia->Text.c_str());
	  if((slice_ultima < slice) && (slice_ultima != 0))
	  {
		 DesabilitaAbilita(3); // fim
		 return;
	  }
	  // reabilita o delay
	  Timer1->Enabled = true;
	  ButtonPausar->Enabled = true;
	  // atualiza a proxima fatia
	  EditProximaFatia->Text = slice;
	  return;
   }
   if(linhas == 1) // se encontrado somente uma, algo est errado
   {
	  Application->MessageBox(("Warning - lines = 1 layer " + FloatToStr(z)).c_str(), "Error", MB_OK + MB_ICONERROR);
	  free(cache_tmp);
	  // para apagar o desenho
	  Image1->Width = 0;
	  Image1->Height = 0;
	  // impressao inicia aqui
	  char titulo[32];
	  sprintf(titulo, "Slice %u (empty)", slice);
	  Label3->Caption = "Printing Slice " + IntToStr(slice) + "\n(empty)";
	  if(CheckBoxImprimir->Checked)
	  {
		 Prntr->Title = titulo;
		 Prntr->BeginDoc(); // inicio da impresso
		 Prntr->EndDoc();  // fim da impresso
	  }
	  // incremento
	  slice++;
	  if(RadioButton1->Checked)
	  {
		 z -= incremento;
		 if(z <= menor[2])
		 {
			DesabilitaAbilita(3); // fim
			return;
		 }
	  }
	  else
	  {
		 z += incremento;
		 if(z >= maior[2])
		 {
			DesabilitaAbilita(3); // fim
			return;
		 }
	  }
	  // verifica se no  a ultima fatia
	  slice_ultima = atoi(EditUltimaFatia->Text.c_str());
	  if((slice_ultima < slice) && (slice_ultima != 0))
	  {
		 DesabilitaAbilita(3); // fim
		 return;
	  }
	  // reabilita o delay
	  Timer1->Enabled = true;
	  ButtonPausar->Enabled = true;
	  // atualiza a proxima fatia
	  EditProximaFatia->Text = slice;
	  return;
   }
   // cria imagem a ser impressa
   pBitmap = new Graphics::TBitmap();
   pBitmap->HandleType = bmDIB;
   pBitmap->Monochrome = true;
   pBitmap->Width = PrinterHORZRES;
   pBitmap->Height = PrinterVERTRES;
   pBitmap->PixelFormat = pf1bit;
   RGBQUAD cor[1];
   cor[0].rgbRed = GetRValue(ColorDialog->Color);
   cor[0].rgbGreen = GetGValue(ColorDialog->Color);
   cor[0].rgbBlue = GetBValue(ColorDialog->Color);
   cor[0].rgbReserved = 0;
   SetDIBColorTable(pBitmap->Canvas->Handle, 0, 1, cor);
   // ajusta a imagem para visualizacao com zoom
   float fator_zoom = float(ComboBoxZoom->ItemIndex + 1)/20;
   Image1->Width = PrinterHORZRES * fator_zoom;
   Image1->Height = PrinterVERTRES * fator_zoom;
   Image1->Picture->Assign(pBitmap);

   Pega_ABS_Fatia(); // pega o max e min de x e y da fatia gerada
   unsigned int yp_start = ((_menor[1] - menor[1])/(25.4/PrinterDPIY));
   for(y = _menor[1]; y < _maior[1]; y += ((25.4/PrinterDPIY))) // comea o scanline-fill
   {
	  unsigned int yp = yp_start++;
	  linhas_slf = 0;
	  cache_tmpy = NULL;
	  for(unsigned int x = 0; x < linhas; x++)
	  {
		 vertices = &cache_tmp[x*4];
		 if(MIN(vertices[1],vertices[3]) <= y && MAX(vertices[1],vertices[3]) > y)
		 {
			diff = MAX(vertices[1],vertices[3]) - MIN(vertices[1],vertices[3]);
			fator = (y-MIN(vertices[1],vertices[3]))/diff;
			if(vertices[1] < vertices[3])
			   diff = (((vertices[2] - vertices[0]) * fator) + vertices[0]);
			else
			   diff = (((vertices[0] - vertices[2]) * fator) + vertices[2]);
			if((p = (float *) realloc (cache_tmpy, ((linhas_slf+1)*4))) == NULL)
			{
			  Application->MessageBox("Error relocate the memory", "Error", MB_OK + MB_ICONERROR);
			  exit(7);
			}
			cache_tmpy = p;
			cache_tmpy[linhas_slf] = diff;
			linhas_slf++;
		 }
	  }
	  if(linhas_slf % 2)
	  {
		 Application->MessageBox(("Warning - Scanline-Fill is odd = " + IntToStr(linhas_slf) + FloatToStr(y)).c_str(), "Error", MB_OK + MB_ICONERROR);
		 free(cache_tmpy);
		 continue;
	  }
	  Ordena_SLF();
	  // Linha
	  for(unsigned int x = 0; x < (linhas_slf/2); x++)
	  {
		 float xse[2]; // x start end
		 xse[0] = cache_tmpy[x*2];
		 xse[1] = cache_tmpy[1+(x*2)];
		 if(((MAX(xse[0],xse[1]) - MIN(xse[0],xse[1]))/(25.4/PrinterDPIX)) <= 0.5) continue;
		 unsigned int xp[2];//, yp = ((/*(maior[1]-menor[1])-*/(y-menor[1]))/(25.4/PrinterDPIY));
		 xp[0] = ((xse[0]-menor[0])/(25.4/PrinterDPIX));
		 xp[1] = ((xse[1]-menor[0])/(25.4/PrinterDPIX));
		 //for(unsigned int a = xp[0]; a <= xp[1]; a++)
		 //{
		 //	pBitmap->Canvas->Pixels[a][yp] = clBlack;
		 //}
		 pBitmap->Canvas->MoveTo(xp[0],yp);
		 pBitmap->Canvas->LineTo(xp[1],yp);
	  }
	  free(cache_tmpy);
   }
   // desenha na tela
   Image1->Canvas->Pen->Color = clWhite;
   Image1->Canvas->Rectangle(0,0,Image1->Width,Image1->Height);
   unsigned int offsetx, offsety, offsetpx, offsetpy;
   if(Button1->Caption == "mm")
   {
	  float fmmx = ((PrinterDPIX)/25.4);
	  float fmmy = ((PrinterDPIY)/25.4);
	  offsetx = atoi(EditOffsetX->Text.c_str())*fator_zoom*fmmx;
	  offsety = atoi(EditOffsetY->Text.c_str())*fator_zoom*fmmy;
	  offsetpx = atoi(EditOffsetX->Text.c_str())*fmmx;
	  offsetpy = atoi(EditOffsetY->Text.c_str())*fmmy;
   }
   else
   {
	  offsetx = atoi(EditOffsetX->Text.c_str())*fator_zoom;
	  offsety = atoi(EditOffsetY->Text.c_str())*fator_zoom;
	  offsetpx = atoi(EditOffsetX->Text.c_str());
	  offsetpy = atoi(EditOffsetY->Text.c_str());
   }
   Image1->Canvas->StretchDraw(Rect(offsetx,offsety,offsetx+Image1->Width,offsety+Image1->Height),pBitmap);
   // impressao inicia aqui
   char titulo[32];
   sprintf(titulo, "Slice %u", slice);
   Label3->Caption = "Printing Slice " + IntToStr(slice);
   if(CheckBoxImprimir->Checked)
   {
	  Prntr->Title = titulo;
	  Prntr->BeginDoc(); // inicio da impresso
	  Prntr->Canvas->Draw(offsetpx,offsetpy,pBitmap);
	  Prntr->EndDoc();  // fim da impresso
   }
   // deleta temporarios na memoria
   free(cache_tmp);
   //incremento
   slice++;
   if(RadioButton1->Checked)
   {
	  z -= incremento;
	  if(z <= menor[2])
	  {
		 DesabilitaAbilita(3); // fim
		 return;
	  }
   }
   else
   {
	  z += incremento;
	  if(z >= maior[2])
	  {
		 DesabilitaAbilita(3); // fim
		 return;
	  }
   }
   // verifica se no  a ultima fatia
   slice_ultima = atoi(EditUltimaFatia->Text.c_str());
   if((slice_ultima < slice) && (slice_ultima != 0))
   {
	  DesabilitaAbilita(3); // fim
	  return;
   }
   // reabilita o delay
   Timer1->Enabled = true;
   ButtonPausar->Enabled = true;
   // atualiza a proxima fatia
   EditProximaFatia->Text = slice;
   return;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonImpressoraClick(TObject *Sender)
{
   PrinterSetupDialog1->Execute();
   Prntr = Printer();
   PrinterDPIX = GetDeviceCaps(Prntr->Handle,LOGPIXELSX);
   PrinterDPIY = GetDeviceCaps(Prntr->Handle,LOGPIXELSY);
   PrinterHORZRES = GetDeviceCaps(Prntr->Handle,HORZRES);
   PrinterVERTRES = GetDeviceCaps(Prntr->Handle,VERTRES);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DesabilitaAbilita(int modo)
{
   if(modo == 0) // STL no carregado, igual quando o programa inicia
   {
	  ButtonProcurar->Enabled = true;
	  ButtonImpressora->Enabled = true;
	  ButtonImprimir->Enabled = false;
	  ButtonPausar->Enabled = false;
	  ButtonCancelar->Enabled = false;

	  ButtonEscalaX->Enabled = false;
	  ButtonEscalaY->Enabled = false;
	  ButtonEscalaZ->Enabled = false;
	  ButtonRotacionaX->Enabled = false;
	  ButtonRotacionaY->Enabled = false;
	  ButtonRotacionaZ->Enabled = false;

	  Memo1->Lines->Clear(); // limpa o memo
	  Edit2->Text = ""; // limpa o numero de fatias
   }
   if(modo == 1) // STL foi carregado
   {
	  ButtonImprimir->Enabled = true;

	  ButtonEscalaX->Enabled = true;
	  ButtonEscalaY->Enabled = true;
	  ButtonEscalaZ->Enabled = true;
	  ButtonRotacionaX->Enabled = true;
	  ButtonRotacionaY->Enabled = true;
	  ButtonRotacionaZ->Enabled = true;
   }
   if(modo == 2) // iniciou a impressao
   {
	  ButtonProcurar->Enabled = false;
	  ButtonImpressora->Enabled = false;
	  ButtonImprimir->Enabled = false;
	  ButtonCancelar->Enabled = true;

	  RadioButton1->Enabled = false;
	  RadioButton2->Enabled = false;

	  EditIncremento->Enabled = false;

	  ButtonEscalaX->Enabled = false;
	  ButtonEscalaY->Enabled = false;
	  ButtonEscalaZ->Enabled = false;
	  ButtonRotacionaX->Enabled = false;
	  ButtonRotacionaY->Enabled = false;
	  ButtonRotacionaZ->Enabled = false;

	  EditProximaFatia->Enabled = true;
	  LabelProximaFatia->Enabled = true;
	  ButtonDecFatia->Enabled = true;
	  ButtonIncFatia->Enabled = true;
   }
   if(modo == 3) // cancelou ou fim da impressao
   {
	  ButtonProcurar->Enabled = true;
	  ButtonImpressora->Enabled = true;
	  ButtonImprimir->Enabled = true;
	  ButtonPausar->Enabled = false;
   	  ButtonPausar->Caption = "Pause";
	  ButtonPausar->Hint = "Pause the print process.";

	  ButtonCancelar->Enabled = false;

	  ButtonEscalaX->Enabled = true;
	  ButtonEscalaY->Enabled = true;
	  ButtonEscalaZ->Enabled = true;
	  ButtonRotacionaX->Enabled = true;
	  ButtonRotacionaY->Enabled = true;
	  ButtonRotacionaZ->Enabled = true;
	  
	  EditIncremento->Enabled = true;

	  RadioButton1->Enabled = true;
	  RadioButton2->Enabled = true;

	  Timer1->Enabled = false;
	  Delay_Pos = 0;
	  Label1->Caption = FloatToStr(float(Delay_Pos)/10) + " sec";
	  ProgressBar1->Position = float(float(Delay_Pos)/Delay)*ProgressBar1->Max;

	  EditProximaFatia->Text = "";
	  EditProximaFatia->Enabled = false;
	  LabelProximaFatia->Enabled = false;
	  ButtonDecFatia->Enabled = false;
	  ButtonIncFatia->Enabled = false;

	  ShowMessage("END");

	  Label3->Caption = "";
	  Image1->Width = 0;
	  Image1->Height = 0;

	  delete pBitmap;
	  pBitmap = NULL; // para nao dar erro quando executar outro delete
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonCancelarClick(TObject *Sender)
{
   DesabilitaAbilita(3);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   if(Delay_Pos >= Delay)
   {
	   ButtonImprimirClick(Sender);
	   Delay_Pos = 0;
	   Label1->Caption = Delay_Pos;
	   ProgressBar1->Position = float(float(Delay_Pos)/Delay)*ProgressBar1->Max;
	   return;
   }
   Delay_Pos++;
   Label1->Caption = FloatToStr(float(Delay_Pos)/10) + " sec";
   ProgressBar1->Position = float(float(Delay_Pos)/Delay)*ProgressBar1->Max;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonPausarClick(TObject *Sender)
{
   if(Timer1->Enabled == false)
   {
	  Timer1->Enabled = true;
	  ButtonPausar->Caption = "Pause";
   }
   else
   {
	  Timer1->Enabled = false;
	  ButtonPausar->Caption = "Continue";
   }
   ButtonPausar->Hint = ButtonPausar->Caption + " the print process.";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ProgressBar1MouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(!STL_esta_carregado) return;
   if(ButtonImprimir->Enabled) return;
   Delay_Pos = (float(float(X) / float(ProgressBar1->Width)) * Delay);
   Label1->Caption = FloatToStr(float(Delay_Pos)/10) + " sec";
   ProgressBar1->Position = float(float(Delay_Pos)/Delay)*ProgressBar1->Max;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditIncrementoChange(TObject *Sender)
{
   incremento = atof(EditIncremento->Text.c_str());
   if(STL_esta_carregado)
   {
	  if(incremento > 0)
	  {
		 unsigned int ks = 0;
		 for(double kz = maior[2]; kz > menor[2]; kz -= incremento) ks++;
		 Edit2->Text = ks;
	  }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditIncrementoEnter(TObject *Sender)
{
   incremento = atof(EditIncremento->Text.c_str());
   if(incremento <= 0)
   {
	  incremento = 1;
	  EditIncremento->Text = "1.0";
   }
   if(STL_esta_carregado)
   {
	  if(incremento > 0)
	  {
		 unsigned int ks = 0;
		 for(double kz = maior[2]; kz > menor[2]; kz -= incremento) ks++;
		 Edit2->Text = ks;
	  }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditIncrementoExit(TObject *Sender)
{
   incremento = atof(EditIncremento->Text.c_str());
   if(incremento <= 0)
   {
	  Application->MessageBox("The increment may not be less equals 0", "Error", MB_OK + MB_ICONERROR);
	  incremento = 1;
	  EditIncremento->Text = "1.0";
   }
   if(STL_esta_carregado)
   {
	  if(incremento > 0)
	  {
		 unsigned int ks = 0;
		 for(double kz = maior[2]; kz > menor[2]; kz -= incremento) ks++;
		 Edit2->Text = ks;
	  }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditDelayExit(TObject *Sender)
{
   if(EditDelay->Text == "")
   {
	   EditDelay->Text = IntToStr(Delay);
	   return;
   }
   unsigned int td;
   td = atoi(EditDelay->Text.c_str());
   if(td > 0) Delay = td;
   EditDelay->Text = IntToStr(Delay);
   Label4->Caption = "Delay " + FloatToStr(float(Delay)/10) + " sec";;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EscalaRotaciona(TObject *Sender)
{
   float escala[3];
   escala[0] = atof(EditEscalaX->Text.c_str());
   escala[1] = atof(EditEscalaY->Text.c_str());
   escala[2] = atof(EditEscalaZ->Text.c_str());

   float cosseno[3];
   float seno[3];
   float temp;

   #define PI 3.14159265358979323846
   #define GRAUS_PARA_RAD(a) (a*PI)/180
   #define RAD_PARA_GRAUS(a) (a/180)*PI

   cosseno[0] = cos(GRAUS_PARA_RAD(EditRotacionaX->Text));
   cosseno[1] = cos(GRAUS_PARA_RAD(EditRotacionaY->Text));
   cosseno[2] = cos(GRAUS_PARA_RAD(EditRotacionaZ->Text));
   seno[0] = sin(GRAUS_PARA_RAD(EditRotacionaX->Text));
   seno[1] = sin(GRAUS_PARA_RAD(EditRotacionaY->Text));
   seno[2] = sin(GRAUS_PARA_RAD(EditRotacionaZ->Text));

   for(unsigned int x = 0; x < *ntt; x++)
   {
	  vertices = (float *) &cache_stl[96+(x*50)];
	  switch(ActiveControl->Tag)
	  {
		 case 0:
		 {
			if(escala[0] == 0)
			{
			   Application->MessageBox("The value of the scale should be different from 0", "Error", MB_OK + MB_ICONERROR);
			   return;
			}
			vertices[0] *= escala[0];
			vertices[3] *= escala[0];
			vertices[6] *= escala[0];
			break;
		 }
		 case 1:
		 {
			if(escala[1] == 0)
			{
			   Application->MessageBox("The value of the scale should be different from 0", "Error", MB_OK + MB_ICONERROR);
			   return;
			}
			vertices[1] *= escala[1];
			vertices[4] *= escala[1];
			vertices[7] *= escala[1];
			break;
		 }
		 case 2:
		 {
			if(escala[2] == 0)
			{
			   Application->MessageBox("The value of the scale should be different from 0", "Error", MB_OK + MB_ICONERROR);
			   return;
			}
			vertices[2] *= escala[2];
			vertices[5] *= escala[2];
			vertices[8] *= escala[2];
			break;
		 }
		 case 3:
		 {
			// Rotaciona em X
			temp = vertices[1];
			vertices[1] = (cosseno[0]*vertices[1]) - (seno[0]*vertices[2]);
			vertices[2] = (cosseno[0]*vertices[2]) + (seno[0]*temp);
			temp = vertices[4];
			vertices[4] = (cosseno[0]*vertices[4]) - (seno[0]*vertices[5]);
			vertices[5] = (cosseno[0]*vertices[5]) + (seno[0]*temp);
			temp = vertices[7];
			vertices[7] = (cosseno[0]*vertices[7]) - (seno[0]*vertices[8]);
			vertices[8] = (cosseno[0]*vertices[8]) + (seno[0]*temp);
			break;
		 }
		 case 4:
		 {
			// Rotaciona em Y
			temp = vertices[0];
			vertices[0] = (cosseno[1]*vertices[0]) + (seno[1]*vertices[2]);
			vertices[2] = (cosseno[1]*vertices[2]) - (seno[1]*temp);
			temp = vertices[3];
			vertices[3] = (cosseno[1]*vertices[3]) + (seno[1]*vertices[5]);
			vertices[5] = (cosseno[1]*vertices[5]) - (seno[1]*temp);
			temp = vertices[6];
			vertices[6] = (cosseno[1]*vertices[6]) + (seno[1]*vertices[8]);
			vertices[8] = (cosseno[1]*vertices[8]) - (seno[1]*temp);
			break;
		 }
		 case 5:
		 {
			// Rotaciona em Z
			temp = vertices[0];
			vertices[0] = (cosseno[2]*vertices[0]) - (seno[2]*vertices[1]);
			vertices[1] = (cosseno[2]*vertices[1]) + (seno[2]*temp);
			temp = vertices[3];
			vertices[3] = (cosseno[2]*vertices[3]) - (seno[2]*vertices[4]);
			vertices[4] = (cosseno[2]*vertices[4]) + (seno[2]*temp);
			temp = vertices[6];
			vertices[6] = (cosseno[2]*vertices[6]) - (seno[2]*vertices[7]);
			vertices[7] = (cosseno[2]*vertices[7]) + (seno[2]*temp);
			break;
		 }
	  }
   }
   // atualiza as coisas
   Pega_ABS();
   Imprime_Cabecalho_Triangulos();
   EditIncrementoChange(Sender); // atualiza o numero de fatias
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FiltroTeclas(TObject *Sender, char &Key)
{
   if(!((Key >= '0' && Key <= '9') || Key == '\b' || Key == '.' || Key == '-')) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FiltroTeclasPositivas(TObject *Sender, char &Key)
{
   if(ActiveControl->Tag == 4 && Key == 13)
   {
	  EditDelayExit(Sender);
	  return;
   }
   if(!((Key >= '0' && Key <= '9') || Key == '\b')) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonIncFatiaClick(TObject *Sender)
{
   if(slice < slice_totais) slice++;
   EditProximaFatia->Text = slice;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonDecFatiaClick(TObject *Sender)
{
   if(slice > 1) slice--;
   EditProximaFatia->Text = slice;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PanelCorClick(TObject *Sender)
{
   ColorDialog->Execute();
   PanelCor->Color = ColorDialog->Color;
   PanelCor->Font->Color = clWhite - ColorDialog->Color;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MudarZoom(TObject *Sender)
{
   if(pBitmap == NULL) return;
   float fator_zoom = float(ComboBoxZoom->ItemIndex + 1)/20;
   Image1->Width = PrinterHORZRES * fator_zoom;
   Image1->Height = PrinterVERTRES * fator_zoom;
   // apaga o desenho antigo
   Image1->Canvas->Pen->Color = clWhite;
   Image1->Canvas->Rectangle(0,0,Image1->Width,Image1->Height);
   unsigned int offsetx, offsety;
   if(Button1->Caption == "mm")
   {
	  float fmmx = ((PrinterDPIX)/25.4);
	  float fmmy = ((PrinterDPIY)/25.4);
	  offsetx = atoi(EditOffsetX->Text.c_str())*fator_zoom*fmmx;
	  offsety = atoi(EditOffsetY->Text.c_str())*fator_zoom*fmmy;
   }
   else
   {
	  offsetx = atoi(EditOffsetX->Text.c_str())*fator_zoom;
	  offsety = atoi(EditOffsetY->Text.c_str())*fator_zoom;
   }
   Image1->Canvas->StretchDraw(Rect(offsetx,offsety,offsetx+Image1->Width,offsety+Image1->Height),pBitmap);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   if(Button1->Caption=="mm")
	  Button1->Caption="pixels";
   else
	  Button1->Caption="mm";
   MudarZoom(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OffsetChange(TObject *Sender)
{
   MudarZoom(Sender);
}
//---------------------------------------------------------------------------
