// -------DOS Parameterabfrage 
void Parse_Arguments(int argc, char *argv[])
{
   if(argc == 1)
   {
       printf("Usage: stl -i c:\\bin.stl\n");
       printf("\n-b = Background Color, example: stl -b 255 255 255, value expressed in RGB");
       printf("\n-c = Model Color, example: stl -c 0 0 0, value expressed in RGB");
       printf("\n-d = DEBUG used by me, but nothing is right :D so dont use");
	   printf("\n-i = Input File, example: stl -i c:\\bin.stl");
       printf("\n-o = Output directory of BMPs, not implemented yet");
       printf("\n-r = Rotate X Y Z, example: stl -r 0 0 90");
       printf("\n-s = Scale X Y Z, example: stl -s 1 0.5 2, the value may never be 0");
       printf("\n-t = Start Slincing from the top");
       printf("\n-x = DPI at X, example: stl -i arquivo -x 322.2");
       printf("\n-y = DPI at Y, example: stl -i arquivo -x 1024 -y 1024");
       printf("\n-l = Layer hight (increment) as option, example: stl -l 0.5");
      printf("\n\nDefault Values:\n-x: 300\n-y: 300\n-r: 0 0 0\n-s; 1 1 1\n-b: 255 255 255\n-c: 0 0 0\n");
       exit(0);
   }
   int optind = 1;
   while (optind < argc)
   {
      if(argv[optind][0] == '-')
      {
         if(argv[optind][1] == 'i' || argv[optind][1] == 'I')
         {
            if(optind < (argc-1))
            {
               file_stl = argv[++optind];
            }
            else
            {
               printf("Lack the *.stl file.");
               exit(0);
            }
         }
         else if(argv[optind][1] == 'x' || argv[optind][1] == 'X')
         {
            if(optind < (argc-1))
            {
               dpix = atof(argv[++optind]);
               if(dpix <= 0)
               {
                  printf("The resolution in X should be greater than 0.");
                  exit(0);
               }
            }
            else
            {
               printf("Lack DPI in X.");
               exit(0);
            }
         }
          else if(argv[optind][1] == 'l' || argv[optind][1] == 'L')
         {
            if(optind < (argc-1))
            {
               increment = atof(argv[++optind]);
               if(increment <= 0)
               {
                  printf("The increment should be greater than 0.");
                  exit(0);
               }
            }
            else
            {
               printf("Lack DPI in X.");
               exit(0);
            }
         }
        else if(argv[optind][1] == 'y' || argv[optind][1] == 'Y')
         {
            if(optind < (argc-1))
            {
               dpiy = atof(argv[++optind]);
               if(dpiy <= 0)
               {
                  printf("The resolution in Y should be greater than 0.");
                  exit(0);
               }
            }
            else
            {
               printf("Lack increment.");
               exit(0);
            }
         }
         else if(argv[optind][1] == 'r' || argv[optind][1] == 'R')
         {
            if(optind < (argc-3))
            {
               angle[0] = atof(argv[++optind]);
               angle[1] = atof(argv[++optind]);
               angle[2] = atof(argv[++optind]);
            }
            else
            {
               printf("Lack argument for the rotation.");
               exit(0);
            }
         }
         else if(argv[optind][1] == 's' || argv[optind][1] == 'S')
         {
            if(optind < (argc-3))
            {
               scale[0] = atof(argv[++optind]);
               scale[1] = atof(argv[++optind]);
               scale[2] = atof(argv[++optind]);
               if(scale[0] == 0)
               {
                  printf("The scale in X must be different of 0.");
                  exit(0);
               }
               if(scale[1] == 0)
               {
                  printf("The scale in Y must be different of 0.");
                  exit(0);
               }
               if(scale[2] == 0)
               {
                  printf("The scale in Z must be different of 0.");
                  exit(0);
               }
            }
            else
            {
               printf("Lack argument for the scale.");
               exit(0);
            }
         }
         else if(argv[optind][1] == 'b' || argv[optind][1] == 'B')
         {
            if(optind < (argc-3))
            {
               Pallet[2] = (unsigned char) atoi(argv[++optind]);
               Pallet[1] = (unsigned char) atoi(argv[++optind]);
               Pallet[0] = (unsigned char) atoi(argv[++optind]);
            }
            else
            {
               printf("Lack argument for the background color.");
               exit(0);
            }
         }
         else if(argv[optind][1] == 'c' || argv[optind][1] == 'C')
         {
            if(optind < (argc-3))
            {
               Pallet[6] = (unsigned char) atoi(argv[++optind]);
               Pallet[5] = (unsigned char) atoi(argv[++optind]);
               Pallet[4] = (unsigned char) atoi(argv[++optind]);
            }
            else
            {
               printf("Lack argument for the color of the model.");
               exit(0);
            }
         }
         else if(argv[optind][1] == 'd' || argv[optind][1] == 'D')
         {
            debug = true;
         }
         else if(argv[optind][1] == 't' || argv[optind][1] == 'T')
         {
            top = true;
         }
         else if(argv[optind][1] == 'o' || argv[optind][1] == 'O')
         {
            if(optind < (argc-1))
            {
               dir = argv[++optind];
            }
            else
            {
               printf("Lack the output directory.");
               exit(0);
            }
         }
         else
         {
            printf("\nInvalid argument: %s",argv[optind]);
            exit(0);
         }
      }
      else
      {
         printf("\nInvalid argument: %s",argv[optind]);
         exit(0);
      }
      optind++;
   }
   BiXPPMeter = long(dpix*(1000/25.4));
   BiYPPMeter = long(dpiy*(1000/25.4));
}




// --------Open STL File
void Open_STL_File(void)
{
   if((stl = fopen(file_stl, "rb")) == NULL)
   {
      printf("\nError opening the file %s.", file_stl);
      exit(1);
   }
    
   // get the file size
   fseek(stl, 0, SEEK_END); // go to the end of the file
   size = ftell(stl); // get the file size
   fseek(stl, 0, SEEK_SET); // back to the beginning of the file
   
   // verify if is less than 4 facets
   if(size < 284)
   {
      printf("\nFile too small to contain data.");
      exit(2);
   }
 
   // try allocate memory for the stl file
   if((cache_stl = (char *) malloc(size)) == NULL)
   {
      printf("\nMemory insufficient for the STL file.");
      exit(3);
   }

   // store the stl file in memory
   if(fread(cache_stl, 1, size, stl) != size)
   {
      printf("\nError reading file %s.",file_stl);
      exit(4);
   }
   
   // close the file
   fclose(stl);
   
   // verify if the size is right for a binary stl file
   ntt = (unsigned long *) &cache_stl[80]; // get the number of triangles
   if((*ntt*50)+84 != size)
   {
      printf("\nThe number of triangles not matched with the file size.");
      printf("\nTriangles: %ld\nSize: %ld",*ntt,size);
	  free(cache_stl);
      exit(5);
   }
}


void Scale_and_Rotate(void)
{
   #define PI 3.14159265
   #define DEGREES_TO_RAD(a) (a*PI)/180
   
   float cosine[3];
   float sine[3];
   float temp;
   
   cosine[0] = cos(DEGREES_TO_RAD(angle[0]));
   sine[0] = sin(DEGREES_TO_RAD(angle[0]));
   cosine[1] = cos(DEGREES_TO_RAD(angle[1]));
   sine[1] = sin(DEGREES_TO_RAD(angle[1]));
   cosine[2] = cos(DEGREES_TO_RAD(angle[2]));
   sine[2] = sin(DEGREES_TO_RAD(angle[2]));

   for(x = 0; x < *ntt; x++)
   {
      vertices = (float *) &cache_stl[96+(x*50)];

      // Scala in X
      vertices[0] *= scale[0];
      vertices[3] *= scale[0];
      vertices[6] *= scale[0];
  
      // Scala in Y
      vertices[1] *= scale[1];
      vertices[4] *= scale[1];
      vertices[7] *= scale[1];
  
      // Scala in Z
      vertices[2] *= scale[2];
      vertices[5] *= scale[2];
      vertices[8] *= scale[2];
  
      // Rotate in X
      temp = vertices[1];
      vertices[1] = (cosine[0]*vertices[1]) - (sine[0]*vertices[2]);
      vertices[2] = (cosine[0]*vertices[2]) + (sine[0]*temp);
      temp = vertices[4];
      vertices[4] = (cosine[0]*vertices[4]) - (sine[0]*vertices[5]);
      vertices[5] = (cosine[0]*vertices[5]) + (sine[0]*temp);
      temp = vertices[7];
      vertices[7] = (cosine[0]*vertices[7]) - (sine[0]*vertices[8]);
      vertices[8] = (cosine[0]*vertices[8]) + (sine[0]*temp);
  
      // Rotate in Y
      temp = vertices[0];
      vertices[0] = (cosine[1]*vertices[0]) + (sine[1]*vertices[2]);
      vertices[2] = (cosine[1]*vertices[2]) - (sine[1]*temp);
      temp = vertices[3];
      vertices[3] = (cosine[1]*vertices[3]) + (sine[1]*vertices[5]);
      vertices[5] = (cosine[1]*vertices[5]) - (sine[1]*temp);
      temp = vertices[6];
      vertices[6] = (cosine[1]*vertices[6]) + (sine[1]*vertices[8]);
      vertices[8] = (cosine[1]*vertices[8]) - (sine[1]*temp);

      // Rotate in Z
      temp = vertices[0];
      vertices[0] = (cosine[2]*vertices[0]) - (sine[2]*vertices[1]);
      vertices[1] = (cosine[2]*vertices[1]) + (sine[2]*temp);
      temp = vertices[3];
      vertices[3] = (cosine[2]*vertices[3]) - (sine[2]*vertices[4]);
      vertices[4] = (cosine[2]*vertices[4]) + (sine[2]*temp);
      temp = vertices[6];
      vertices[6] = (cosine[2]*vertices[6]) - (sine[2]*vertices[7]);
      vertices[7] = (cosine[2]*vertices[7]) + (sine[2]*temp);
   }
}

void Print_Header_Triangles(void)
{
   // print the header
   printf("Header: ");   
   for(x = 0; x < 80; x++)
   {
      if(cache_stl[x] == 0) break;
      printf("%c",cache_stl[x]);
   }

   // print the number of triangles
   printf("\nNumber of triangles: %lu\n", *ntt);

   // keys for debug
   // j = goto
   // space = stop or continue
   // esc = quit
   // all others keys = next facet
   if(debug)
   {
      bool jump_increment = false;
      for(x=0;x<*ntt;(jump_increment) ? jump_increment = false : x++)
      {
         vertices = (float *) &cache_stl[84+(x*50)];
         printf("\n#%ld - Normal: %f %f %f", x+1, vertices[0], vertices[1], vertices[2]);
         printf("\n#%ld - P1: %f %f %f", x+1, vertices[3], vertices[4], vertices[5]);
         printf("\n#%ld - P2: %f %f %f", x+1, vertices[6], vertices[7], vertices[8]);
         printf("\n#%ld - P3: %f %f %f\n", x+1, vertices[9], vertices[10], vertices[11]);
         if(x==*ntt-1)
         {
            printf("\nEnd of List");
            continue;
         }
         if(!continuous)
         {
            key = (char) getch();
            if(key == 0) key = (char) getch();
            if(key == 27) break;
            if(key == 32) continuous = 1;
            if(key == 'j')
            {
               printf("\nJump to which address?\nBetween 1 a %lu: ",*ntt);
               char input[256];
               unsigned long jump;
               gets(input);
               jump = strtoul(input,NULL,10);
               if(jump > 0 && jump <= *ntt) 
               {
                  jump_increment = true;
                  x = jump-1;
               }
            }
         }
         else
         {
            if(kbhit() && continuous)
            {
               key = (char) getch();
               if(key == 0) key = (char) getch();
               if(key == 27) break;
               if(key == 32) continuous = 0;
               if(key == 'j')
               {
                  printf("\nJump to witch address?\nBetween 1 a %lu: ",*ntt);
                  char input[256];
                  unsigned long jump;
                  gets(input);
                  jump = strtoul(input,NULL,10);
                  if(jump > 0 && jump <= *ntt) 
                  {
                     jump_increment = true;
                     x = jump-1;
                  }
               }
            }
         }
      }
      getch();
      clrscr();
	  // reprints the header
      printf("Header: ");   
      for(x = 0; x < 80; x++)
      {
         if(cache_stl[x] == 0) break;
         printf("%c",cache_stl[x]);
      }
      printf("\nNumber of triangles: %lu\n", *ntt);  
   }
}

void Get_ABS(void)
{
   for(x = 0; x < (*ntt-1); x++)
   {
      vertices = (float *) &cache_stl[96+(x*50)];
      if(x == 0)
      {
         minimum[0] = vertices[0]; maximum[0] = vertices[0];
         minimum[1] = vertices[1]; maximum[1] = vertices[1];
         minimum[2] = vertices[2]; maximum[2] = vertices[2];
      }
      else
      {
         if(minimum[0] > vertices[0]) minimum[0] = vertices[0];
         if(minimum[1] > vertices[1]) minimum[1] = vertices[1];
         if(minimum[2] > vertices[2]) minimum[2] = vertices[2];
         if(maximum[0] < vertices[0]) maximum[0] = vertices[0];
         if(maximum[1] < vertices[1]) maximum[1] = vertices[1];
         if(maximum[2] < vertices[2]) maximum[2] = vertices[2];
      }
      if(minimum[0] > vertices[3]) minimum[0] = vertices[3];
      if(minimum[0] > vertices[6]) minimum[0] = vertices[6];
      if(minimum[1] > vertices[4]) minimum[1] = vertices[4];
      if(minimum[1] > vertices[7]) minimum[1] = vertices[7];
      if(minimum[2] > vertices[5]) minimum[2] = vertices[5];
      if(minimum[2] > vertices[8]) minimum[2] = vertices[8];
      
      if(maximum[0] < vertices[3]) maximum[0] = vertices[3];
      if(maximum[0] < vertices[6]) maximum[0] = vertices[6];
      if(maximum[1] < vertices[4]) maximum[1] = vertices[4];
      if(maximum[1] < vertices[7]) maximum[1] = vertices[7];
      if(maximum[2] < vertices[5]) maximum[2] = vertices[5];
      if(maximum[2] < vertices[8]) maximum[2] = vertices[8];
   }
   BiWidth = long(((maximum[0]-minimum[0])/(25.4/dpix)));
   BiHeight = long(((maximum[1]-minimum[1])/(25.4/dpiy)));
   BytesPerLine = (BiWidth/8)+((BiWidth%8)?1:0);
   BytesPerLine += (4-((BytesPerLine%4) ? (BytesPerLine%4) : 4));
}

void Print_ABS(void)
{
   printf("\nmin_abs: %f %f %f",minimum[0],minimum[1],minimum[2]);
   printf("\nmax_abs: %f %f %f",maximum[0],maximum[1],maximum[2]);
   printf("\nsize:    %f %f %f",maximum[0]-minimum[0],maximum[1]-minimum[1],maximum[2]-minimum[2]);
   printf("\n\ndpi x: %.1f\ndpi y: %.1f",dpix,dpiy);
}

void Create_Menu(void)
{
   printf("\n\nlayers:\nincrement:\nconverted value:\ntotal size:\nsize of image:\n\npress ESC to quit.");
   gotoxy(12,wherey()-5); // position of input increment

   key = 0;
   char input[12] = {0,0,0,0,0,0,0,0,0,0,0,0};
   int pos = 0, decimal = 0;
   while(key == 0)
   {
      int cursor;
      cursor = wherex();

      gotoxy(18,wherey()+1);
      printf("                     "); // to delete the old value
      gotoxy(18,wherey());
      increment = atof(input);
      printf("%.9f",increment); // real increment

      gotoxy(13,wherey()+1);
      printf("                     "); // to delete the old value
      gotoxy(13,wherey());
      float fisz = float((62+(BytesPerLine * BiHeight))/1024);
      if(increment > 0) printf("%.1f MB", (fisz * ((maximum[2]-minimum[2])/increment))/1024); // tamanho total

      gotoxy(16,wherey()+1);
      printf("                      "); // to delete the old value
      gotoxy(16,wherey());
      printf("%.1f KB", fisz); // size of image

      gotoxy(9, wherey()-4);
      printf("                      "); // to delete the old value
      gotoxy(9, wherey());
      if(increment > 0) printf("%.1f",(maximum[2]-minimum[2])/increment);
      else printf("infinity"); // layers

      gotoxy(cursor, wherey()+1);

      key = (char) getch(); // Tastaturabfrage 
      if((key >= '0' && key <='9') || key == '.' || key == '\b' || key == '\r' || key == 27)
      {
         if(key == 27) // ESC
         {
            printf("\n\n\n\n\n\n");
            exit(6);
         } 
         if(key == '\b' && pos > 0) //backspace
         {
            pos--;
            if(input[pos] == '.') decimal = 0;
            input[pos] = '\0'; printf("\b \b");
         }
         if(key == '.' && (pos > 0 && pos < 11) && decimal == 0) // Dezimal
         {
            input[pos] = '.'; printf(".");
            pos++; decimal = 1;
         }
         if((key >= '0' && key <= '9') && pos < 11) // Gltige Zahl
         {
            input[pos] = key; printf("%c", key);
            pos++;
         }
         if(key == '\r' && input[pos-1] != '.' && increment > 0) break;
         key=0;
      }
      else if(key != 0) key = 0;
   }
   printf("\n\n\n\n\n\n");
}

void Is_Between(void)
{
   lines = 0; // initializes the variable
   free(cache_slice); // clean the memory
   cache_slice = NULL; // initializes the variable, when using the realloc will work equal to malloc
   for(x = 0; x < *ntt; x++)
   {
      vertices = (float *) &cache_stl[96+(x*50)];
      float final[3][2]; // store the coordinated where was intersected
      int cnt=0, cntpos=0;
      if(vertices[2] == z) // endpoint P1
      {
         final[cnt][0] = vertices[0];
         final[cnt][1] = vertices[1];
         cnt++; cntpos += 1;
      }
      if(vertices[5] == z) // endpoint P2
      {
         final[cnt][0] = vertices[3];
         final[cnt][1] = vertices[4];
         cnt++; cntpos += 2;
      }
      if(vertices[8] == z) // endpoint P3
      {
         final[cnt][0] = vertices[6];
         final[cnt][1] = vertices[7];
         cnt++; cntpos += 4;
      }
      if((vertices[2] > z && vertices[5] < z) || (vertices[5] > z && vertices[2] < z)) // middle between P1-P2
      {
         diff = MAX(vertices[2],vertices[5]) - MIN(vertices[2],vertices[5]);
         factor = (z-MIN(vertices[2],vertices[5]))/diff;
         if(vertices[2] < vertices[5])
         {
            final[cnt][0] = (((vertices[3] - vertices[0]) * factor) + vertices[0]);
            final[cnt][1] = (((vertices[4] - vertices[1]) * factor) + vertices[1]);
            cnt++;
         }
         else
         {
            final[cnt][0] = (((vertices[0] - vertices[3]) * factor) + vertices[3]);
            final[cnt][1] = (((vertices[1] - vertices[4]) * factor) + vertices[4]);
            cnt++;
         }
      }
      if((vertices[2] > z && vertices[8] < z) || (vertices[8] > z && vertices[2] < z)) // middle between P1-P3
      {
         diff = MAX(vertices[2],vertices[8]) - MIN(vertices[2],vertices[8]);
         factor = (z-MIN(vertices[2],vertices[8]))/diff;
         if(vertices[2] < vertices[8])
         {
            final[cnt][0] = (((vertices[6] - vertices[0]) * factor) + vertices[0]);
            final[cnt][1] = (((vertices[7] - vertices[1]) * factor) + vertices[1]);
            cnt++;
         }
         else
         {
            final[cnt][0] = (((vertices[0] - vertices[6]) * factor) + vertices[6]);
            final[cnt][1] = (((vertices[1] - vertices[7]) * factor) + vertices[7]);
            cnt++;
         }
      }
      if((vertices[8] > z && vertices[5] < z) || (vertices[5] > z && vertices[8] < z)) // middle between P2-P3
      {
         diff = MAX(vertices[8],vertices[5]) - min(vertices[8],vertices[5]);
         factor = (z-MIN(vertices[8],vertices[5]))/diff;
         if(vertices[8] < vertices[5])
         {
            final[cnt][0] = (((vertices[3] - vertices[6]) * factor) + vertices[6]);
            final[cnt][1] = (((vertices[4] - vertices[7]) * factor) + vertices[7]);
            cnt++;
         }
         else
         {
            final[cnt][0] = (((vertices[6] - vertices[3]) * factor) + vertices[3]);
            final[cnt][1] = (((vertices[7] - vertices[4]) * factor) + vertices[4]);
            cnt++;
         }
      }
      if(cnt == 1 && cntpos > 0) // 1 endpoint
      {
         //printf("\n#%ld P - %f %f", x+1, final[0][0], final[0][1]);
      }
      if(cnt == 2) // line
      {
         if(cntpos == 0) // 2 middle
         {
            //printf("\n#%ld L - %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1]);
            if(final[0][1] != final[1][1]) // store, if not is a horizontal line
            {
			   if((p = (float *) realloc (cache_slice, (lines+1)*16)) == NULL)
               {
                  printf("Error (re)allocating memory"); 
                  exit(7);
               }
               cache_slice = p;
               cache_slice[(lines*4)+0] = final[0][0];
               cache_slice[(lines*4)+1] = final[0][1];
               cache_slice[(lines*4)+2] = final[1][0];
               cache_slice[(lines*4)+3] = final[1][1];
               lines++;
            }
         }
         else if((cntpos == 1) || (cntpos == 2) || (cntpos == 4)) // 1 endpoint 1 middle
         {
            //printf("\n#%ld PL - %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1]);
            if(final[0][1] != final[1][1]) // store, if not is a horizontal line
            {
               if((p = (float *) realloc (cache_slice, (lines+1)*16)) == NULL)
               {
                  printf("Error (re)allocating memory"); 
                  exit(7);
               }
               cache_slice = p;
               cache_slice[(lines*4)+0] = final[0][0];
               cache_slice[(lines*4)+1] = final[0][1];
               cache_slice[(lines*4)+2] = final[1][0];
               cache_slice[(lines*4)+3] = final[1][1];
               lines++;
            }
         }
         else // 2 endpoints
         {
            //printf("\n#%ld FL - %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1]);
            if(final[0][1] != final[1][1]) // store, if not is a horizontal line
            {
               if((top) ? ((vertices[2] < z) || (vertices[5] < z) || (vertices[8] < z)): 
			              ((vertices[2] > z) || (vertices[5] > z) || (vertices[8] > z)))
               {
                  if((p = (float *) realloc (cache_slice, (lines+1)*16)) == NULL)
                  {
                     printf("Error (re)allocating memory");
                     exit(7);
                  }
                  cache_slice = p;
                  cache_slice[(lines*4)+0] = final[0][0];
                  cache_slice[(lines*4)+1] = final[0][1];
                  cache_slice[(lines*4)+2] = final[1][0];
                  cache_slice[(lines*4)+3] = final[1][1];
                  lines++;
               }
            }
         }
      }
      if(cnt == 3 && cntpos == 7) // face plane in Z
      {
        //printf("\n#%ld F - %f %f %f %f %f %f", x+1, final[0][0], final[0][1], final[1][0], final[1][1], final[2][0], final[2][1]);
      }
   } // end of the loop of triangles
   if(debug)
   {
      printf("\nlines found: %lu %f",lines, z);
      getch();
   }
}

void Get_ABS_Slice(void)
{
   for(x = 0; x < (lines*2); x++)
   {
      vertices = &cache_slice[x*2];    
      if(x == 0)
      {
         _minimum[0] = vertices[0]; _maximum[0] = vertices[0];
         _minimum[1] = vertices[1]; _maximum[1] = vertices[1];
      }
      else
      {
         if(_minimum[0] > vertices[0]) _minimum[0] = vertices[0];
         if(_minimum[1] > vertices[1]) _minimum[1] = vertices[1];
         if(_maximum[0] < vertices[0]) _maximum[0] = vertices[0];
         if(_maximum[1] < vertices[1]) _maximum[1] = vertices[1];
      }
   }
   if(debug)
   {      
      printf("\nmin_xy: %f %f",_minimum[0],_minimum[1]);
      printf("\nmax_xy: %f %f",_maximum[0],_maximum[1]);
      printf("\nbox:   %f %f\n",_maximum[0]-_minimum[0],_maximum[1]-_minimum[1]);
   }
}

void Order_SLF(void)
{
   for(x = 0; x < lines_slf; x++)
   {
      if(x == (lines_slf-1)) break; // to fix a strange bug
      float origin = cache_scanline[x];
      unsigned long pmin = x; 
      for(i = (x+1); i < lines_slf; i++)
      {
         if(cache_scanline[x] > cache_scanline[i])
         {
            cache_scanline[x] = cache_scanline[i];
            pmin = i;
         }
      }
      if(pmin != x)
      {
         cache_scanline[pmin] = origin;                  
      }
   }
   if(debug)
   {
      for(x = 0; x < lines_slf; x++)
      {
         printf("\n:%f", cache_scanline[x]);
      }
      getch();
   }
}

void Create_BMP(void)
{
   char fileout[13], zerout[8] = {0,0,0,0,0,0,0,0};
   int zeros = 7, o;
   
   for(o=slice;o/10;o/=10) zeros--;
   for(o=0;o<zeros;o++) zerout[o] = '0';
   zerout[zeros] = 0;
   
   sprintf(fileout,"%s%lu.bmp",zerout, slice);
   image = fopen(fileout, "wb+");

   unsigned char BfType[2] = {'B','M'};
   unsigned int  BfReser1 = 0;
   unsigned int  BfReser2 = 0;
   unsigned long BfOffSetBits = 62;

   unsigned long BiSize = 40;
   unsigned int  BiPlanes = 1;
   unsigned int  BiBitCount = 1;
   unsigned long BiCompress = 0;
   unsigned long BiSizeImag = BytesPerLine * BiHeight;
   unsigned long BfSize = (62 + BiSizeImag);
   unsigned long BiClrUsed = 0;
   unsigned long BiClrImpor = 0;

   // set the file size
   fseek(image,BfSize-1,SEEK_SET); // jump to the last byte
   fputc(0,image); // write a null char
   fseek(image,0,SEEK_SET); // back to start of file

   fwrite(&BfType,1,2,image);       // Signature
   fwrite(&BfSize,4,1,image);       // File Size
   fwrite(&BfReser1,2,1,image);     // Reserved 1
   fwrite(&BfReser2,2,1,image);     // Reserved 2
   fwrite(&BfOffSetBits,4,1,image); // OffSet to beginning of the image

   fwrite(&BiSize,4,1,image);       // Size of the header
   fwrite(&BiWidth,4,1,image);      // Width of the image
   fwrite(&BiHeight,4,1,image);     // Height of the image
   fwrite(&BiPlanes,2,1,image);
   fwrite(&BiBitCount,2,1,image);
   fwrite(&BiCompress,4,1,image);
   fwrite(&BiSizeImag,4,1,image);
   fwrite(&BiXPPMeter,4,1,image);
   fwrite(&BiYPPMeter,4,1,image);
   fwrite(&BiClrUsed,4,1,image);
   fwrite(&BiClrImpor,4,1,image);
   fwrite(&Pallet,1,8,image);
}

void BMP_Line(unsigned long sx,unsigned long ex)
{
   if(sx == ex) return;
   while(sx<ex)
   {
      if(buffer_line != NULL)
      {
         j = sx/8;
         buffer_line[j] |= (char) (128>>(sx%8));
         sx++;
      }
   }
}

void Clean_Buffer(void)
{
   for(x = 0; x < BytesPerLine; x++) buffer_line[x] = 0;
}